#include <iostream>

#include "etsi_ts103097_certificate_EncDec.hh"

namespace etsi__ts103097__certificate__EncDec {

  BITSTRING fx__enc__CertificateBase(const Ieee1609Dot2::CertificateBase &p_cert) {
    std::cout << ">>> fx__enc__CertificateBase" << std::endl;
    TTCN_EncDec::clear_error();
    TTCN_Buffer buffer;
    p_cert.encode(*p_cert.get_descriptor(), buffer, TTCN_EncDec::CT_OER);
    BITSTRING b = oct2bit(OCTETSTRING(buffer.get_len(), buffer.get_data()));

    return b;
  }

  INTEGER fx__dec__CertificateBase(BITSTRING &b, Ieee1609Dot2::CertificateBase &p_cert) {
    std::cout << ">>> fx__dec__CertificateBase" << std::endl;
    TTCN_EncDec::clear_error();
    TTCN_Buffer decoding_buffer(bit2oct(b));
    p_cert.decode(*p_cert.get_descriptor(), decoding_buffer, TTCN_EncDec::CT_OER);
    return 0;
  }

  INTEGER fx__dec__etsi__ts103097__data__encode(const Ieee1609Dot2::Ieee1609Dot2Data &p_ieee1609Dot2Data, OCTETSTRING& p_data) {
    std::cout << ">>> fx__dec__etsi__ts103097__data__encode::encode" << std::endl;

    TTCN_EncDec::clear_error();
    TTCN_Buffer buffer;
    p_ieee1609Dot2Data.encode(*p_ieee1609Dot2Data.get_descriptor(), buffer, TTCN_EncDec::CT_OER);
    p_data = OCTETSTRING(buffer.get_len(), buffer.get_data());

    return 0;
  }

  INTEGER fx__dec__etsi__ts103097__data__decode(const OCTETSTRING &p_data, Ieee1609Dot2::Ieee1609Dot2Data &p_ieee1609Dot2Data) {
    std::cout << ">>> fx__dec__etsi__ts103097__data__decode" << std::endl;

    TTCN_EncDec::clear_error();
    TTCN_Buffer decoding_buffer(p_data);
    p_ieee1609Dot2Data.decode(*p_ieee1609Dot2Data.get_descriptor(), decoding_buffer, TTCN_EncDec::CT_OER);
  
    return 0;
  }

}